#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include "H:\Projekt\sdl\sdl.h"
#include "video.h"
#define M_PI       3.14159265358979323846

// Wieviele Scheiben?
#define MAX_SCHEIBEN 64

void InitRects(SDL_Surface *, SDL_Surface **, SDL_Surface *[], int);
int  DrawTowers(SDL_Surface *screen, SDL_Surface *sTower, SDL_Surface *sDisk[], int, int **, int, int);

int main(int argc, char *argv[])
{
	int i, j=0;
	int a, b, c, atop, btop, ctop;
	int hanoi[3][MAX_SCHEIBEN]= {0};
	int usedScheiben = 15;
	int top[3]= {0};
	int start=0;	// erster, zu testender turm
	int steps=0;	//zhlt die bentigten Schritte
	int delay=500;	// frameverzgerung

	SDL_Surface *screen;
	Uint8 *keys;
	SDL_Event event;
	SDLMod mods;

	SDL_Surface *sTower, *sDisk[MAX_SCHEIBEN];	// die Rechtecke fr Trme und Scheiben.

	// 
	printf("Caliga's Tuerme von Hanoi          www.caligamedia.de     mail@caligamedia.de\n\n\n");
	printf("Wie viele Scheiben sollen umgeschichtet werden? (1-64) Sinnvoll: < 10\n");
	scanf("%i", &usedScheiben);	fflush(stdin);
	if((usedScheiben > 64) || (usedScheiben < 1))		usedScheiben = 8;
	printf("Es werden %i Scheiben benutzt\n\n", usedScheiben);
	printf("              Beenden mit ESC\n");
	printf("              Geschwindigkeit aendern mit NUMPAD +/-\n\n\n");
	printf("Beliebige Taste druecken um fortzufahren...\n");
	getch();

	for (i=0; i<usedScheiben; i++)	hanoi[0][i]=usedScheiben-i;
	top[0]= usedScheiben-1; //voller Turm
	top[1]= -1;				//leer
	top[2]= -1;

	// | Operator zur Verknpfung von mehreren flags
	SDL_Init(SDL_INIT_VIDEO);

	screen = SDL_SetVideoMode(640, 480, 32, SDL_SWSURFACE);
	if ( screen == NULL ) {
		fprintf(stderr, "Ich konnte kein Fenster mit der Auflsung 640*480 ffnen: %s\n", SDL_GetError());
		exit(1);
	}

	InitRects(screen, &sTower, sDisk, usedScheiben);	// die Rechtecke fr Trme und Scheiben initialisieren

	// Main Loop
	while( 1 )
	{
		// Poll for events
		while( SDL_PollEvent( &event ) )
		{
			if ( event.type == SDL_QUIT) exit(0);           
		}
		keys = SDL_GetKeyState(NULL);
		mods = SDL_GetModState();
		//Exit Hanoi
		if (keys[SDLK_ESCAPE] == SDL_PRESSED) break;
		if ((keys[SDLK_KP_PLUS]  == SDL_PRESSED) && (delay>= 100)){ delay-=100; printf("delay: %i\n", delay); }
		if ((keys[SDLK_KP_MINUS] == SDL_PRESSED) && (delay<10000)){ delay+=100; printf("delay: %i\n", delay); }

		DrawTowers(screen, sTower, sDisk, usedScheiben, hanoi, steps, delay);

		// Berechnung
		for(i=0; i<3; i++)
		{
			//start=0;
			a = (start+i)%3;	b = (start+i+1)%3; c = (start+i+2)%3;
			atop = top[a];
			btop = top[b]; // einer der beiden anderen Trme
			ctop = top[c]; // einer der beiden anderen Trme
			//printf("top a:%i    for: %i\n", top[a], i);
			if(top[a] > -1) //turm ist nicht leer?
			{
						// zielturm leer? oder groessere Scheibe?
				if( (btop == -1)  ||  (btop > -1) && (hanoi[a][atop] < hanoi[b][btop]) )
				{
					hanoi[b][btop+1] = hanoi[a][atop];
					hanoi[a][atop] = 0; //nur der Ordnung halber...
					top[a]--; // quellturm 1 niedriger
					top[b]++; // zielturm 1 hoeher
					start = c; //nchstes Mal c zuerst testen.
					steps++;
					break;	// ausgabe, dann von vorn...
				}
					// c leer ODER a kleiner c
				if( (ctop == -1)  ||  (ctop > -1) && (hanoi[a][atop] < hanoi[c][ctop]) )
				{
					hanoi[c][ctop+1] = hanoi[a][atop];
					hanoi[a][atop] = 0; //nur der Ordnung halber...
					top[a]--; // quellturm 1 niedriger
					top[c]++; // zielturm 1 hoeher
					start = b; //nchstes Mal b zuerst testen.
					steps++;
					break;	// ausgabe, dann von vorn...
				}


			} // if turm nicht leer
		} // for 3

	} // while (MAIN loop)
    return 0;
}

void InitRects(SDL_Surface *screen, SDL_Surface **sTower, SDL_Surface *sDisk[], int usedScheiben)
{
	int i, j, k;
	int b, g;
	double colorfactor;
	int stabbreite, disk_w, disk_h;
	Uint32 color;

	stabbreite = screen->w/25;
	*sTower = SDL_CreateRGBSurface(SDL_SWSURFACE, stabbreite, screen->h, 32, screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, screen->format->Amask);

	SDL_LockSurface(*sTower);
	for(i=0; i < (*sTower)->w; i++)
	{
		g = 127.5 + 127.5 * sin(M_PI * i/(*sTower)->w);
		color = SDL_MapRGB(screen->format, 255, g, 0);
		for(j=1; j < (*sTower)->h; j++)	putpixel(*sTower, i, j, color);
	}
    SDL_UnlockSurface(*sTower);
	SDL_UpdateRect(*sTower, 0, 0, 0, 0);


	disk_w = screen->w/4;
	disk_h = (screen->h*0.95)/usedScheiben;
	//for(k=0; k < MAX_SCHEIBEN; k++)
	for(k=usedScheiben; k >=0; k--)
	{
		sDisk[k] = SDL_CreateRGBSurface(SDL_SWSURFACE, disk_w, disk_h, 32, screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, screen->format->Amask);
		disk_w *= 0.9;
		if (disk_w < 1) disk_w = 1;

		colorfactor = 1;
		SDL_LockSurface(sDisk[k]);
		for(i=0; i < (sDisk[k])->w; i++)
		{
			for(j=1; j < (sDisk[k])->h; j++)
			{
				b = 127.5 + 127.5 * sin(M_PI * i/(sDisk[k])->w) * sin(M_PI * j/(sDisk[k])->h);
				b*= colorfactor;
				color = SDL_MapRGB(screen->format, 0, 0, b);
				putpixel(sDisk[k], i, j, color);
			}
		}
		colorfactor*= 0.9;
		SDL_UnlockSurface(sDisk[k]);
		SDL_UpdateRect(sDisk[k], 0, 0, 0, 0);
	}
}

int DrawTowers(SDL_Surface *screen, SDL_Surface *sTower, SDL_Surface *sDisk[], int usedScheiben, int hanoi[3][MAX_SCHEIBEN], int steps, int delay )
{
	SDL_Rect dst;

	int i, j, disk;
	Uint32 color;
	color = SDL_MapRGB(screen->format, 255, 255, 255);

	dst.x = 40; dst.y = 0;



	SDL_FillRect(screen, NULL, 0); // schwarz

	for(i=0; i<3; i++)
	{
		dst.y = 0;
		dst.x = (screen->w + sTower->w)/4*(i+1) - sTower->w/2;
		SDL_BlitSurface(sTower, NULL, screen, &dst);
	}
			
			//printf("%s%s%s\n", scheibe[hanoi[0][i]], scheibe[hanoi[1][i]], scheibe[hanoi[2][i]] );
	for(i=0; i<3; i++)
	{	for(j=0; j<usedScheiben; j++)
		{
			disk = hanoi[i][j];

			if(disk > 0)	// 0= leer
			{
				dst.x = (screen->w + sTower->w)/4*(i+1) - sDisk[disk]->w/2;
				dst.y = screen->h - sDisk[disk]->h*(j+1);
				SDL_BlitSurface(sDisk[disk], NULL, screen, &dst);
			}
		}
	}
	//if(SDL_LockSurface(screen) < 0){ fprintf(stderr, "Can't lock screen: %s\n", SDL_GetError()); return 0; }
	//for(i=0; i<600; i++)	putpixel(screen, i, 55, color);
	Zahlenausgabe(screen, steps);
	//SDL_UnlockSurface(screen);
	SDL_UpdateRect(screen, 0, 0, 0, 0);
	SDL_Delay(delay);
}

//void DrawFilledRect();