void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}


//10 zahlen, 8 hoch 5 breit: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, :, s, t, e, p
int zahl[8][15][5] =
{
	{{1,1,1,1,1}, {0,0,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}},
	{{1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,0}, {1,0,0,0,0}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}, {0,1,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}},
	{{1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,0}, {1,0,0,0,0}, {0,0,0,1,0}, {1,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,1}, {1,1,1,1,0}, {1,1,1,1,0}, {1,1,1,1,0}, {1,1,1,1,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,1,1}, {1,0,0,0,0}, {0,1,0,0,0}, {1,0,0,1,0}, {1,0,0,1,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,0}, {1,1,1,1,0}, {0,1,0,0,0}, {1,1,1,1,0}, {1,1,1,1,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,0}, {0,0,0,1,0}, {0,1,0,0,0}, {1,0,0,0,0}, {1,0,0,0,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,1,1}, {0,0,0,1,0}, {0,1,0,0,0}, {1,0,0,0,0}, {1,0,0,0,0}}, 
	{{1,1,1,1,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,1,0}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,1,1}, {1,1,1,1,0}, {0,1,1,0,0}, {1,1,1,1,0}, {1,0,0,0,0}} 

//{,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, 

};

void Output(SDL_Surface *, char *, int, int, Uint32);

void Zahlenausgabe(SDL_Surface *screen, int steps)
{
	int decimal, sign, x, y, i;
	char temp[20], sSteps[30], *buffer;
	SDL_Rect dest;
	Uint32 color = SDL_MapRGB(screen->format, 255, 255, 255);

	// steps
	itoa(steps, temp, 10);
	strcpy(sSteps, "steps: ");
	strcat(sSteps, temp);
	
	dest.x = 10;	dest.y = 5;	dest.h = 33;	dest.w = 50;
	SDL_FillRect(screen, &dest, 0);
	
	x=15;	y = 10;
	Output(screen, sSteps, x, y, color);
}

void Output(SDL_Surface *screen, char *String, int xpos, int ypos, Uint32 color)
{
	int i,j,k,x;
	SDL_Rect dest;
	dest.x = xpos; dest.y = ypos;
	dest.y+=5;
	dest.x+=10;

	x=0;
	while (1)
	{
		switch (String[x])
		{
		case 0:		k=-1; break;
		case '0': 	k=0; break;
		case '1': 	k=1; break;
		case '2': 	k=2; break;
		case '3': 	k=3; break;
		case '4': 	k=4; break;
		case '5': 	k=5; break;
		case '6': 	k=6; break;
		case '7': 	k=7; break;
		case '8': 	k=8; break;
		case '9': 	k=9; break;
		case ':': 	k=10; break;
		case 's': 	k=11; break;
		case 't': 	k=12; break;
		case 'e':	k=13; break;
		case 'p':	k=14; break;
		case ' ':
		default:	k=-2; break;
		}
		x++;
		if (k==-1) break;
		if (k==-2){ dest.x+=6;	continue; }

		for (i=0; i<8; i++)
		{
			for (j=0; j<5; j++)
			{
				if(zahl[i][k][j]) if ( (dest.y+i > 0) && (dest.y+i < screen->h) )putpixel(screen, dest.x+j, dest.y+i, color);
			}
		} //for i
		dest.x+=6;

	} //while
}